/* an example of a chapms-v2 attack */
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include "sha.h"

/* taken from ppp/pppd/chap_ms.c
 *  Copyright (c) 1995 Eric Rosenquist, Strata Software Limited.
 * http://www.strataware.com/ 
 */

void
ChallengeHash(PeerChallenge, AuthenticatorChallenge, username, Challenge)
char *PeerChallenge;
char *AuthenticatorChallenge;
char *username;
char *Challenge;
{
	SHA_CTX Context;
	unsigned char Digest[SHA_DIGEST_LENGTH];


	SHA1_Init(&Context);
	SHA1_Update(&Context, PeerChallenge, 16);
	SHA1_Update(&Context, AuthenticatorChallenge, 16);
	SHA1_Update(&Context, username, strlen(username));
	SHA1_Final(Digest, &Context);

	memcpy(Challenge, Digest, 8);
}

/* written from scratch
 * Copyright (C) 2001 Jochen Eisinger, University of Freiburg
 */

#define hex2int(c)	((((c) >= '0') && ((c) <= '9')) ? ((c) - '0') : \
			((((c) >= 'A') && ((c) <= 'F')) ? ((c) - 'A' + 10) : \
			((c) - 'a' + 10)))

/* GetCharArray:
 * 	Convert ASCII String to binary
 */
void GetCharArray(char *s, unsigned char *a)
{

	int i, w;

	for (i = 0; i < strlen(s); i += 2) {

		w = hex2int(s[i]);
		w <<= 4;
		w += hex2int(s[i + 1]);

		a[i >> 1] = w;

	}

}

/* PutCharArray:
 * 	Convert binary to ASCII String
 */
char hexcode[] = "0123456789abcdef";
void PutCharArray(unsigned char *a, int c)
{
	int i;
	for (i = 0; i < c; i++)
		printf("%c%c", hexcode[a[i] >> 4], hexcode[a[i] & 15]);
}

/* the SHA1 hash of the challenge, peer_challenge & username */
unsigned char challengehash[8];

void genChallengeHash(char *s1, char *s2, char *s3)
{
	/* the challenge send by the server */
	unsigned char challenge[16];
	/* the challenge send by the peer */
	unsigned char peer_challenge[16];


	GetCharArray(s1, challenge);
	GetCharArray(s2, peer_challenge);

	ChallengeHash(peer_challenge, challenge, s3, challengehash);

}

int main(int argc, char **argv)
{


	puts("Copyright (C) 2001 Jochen Eisinger, University of Freiburg");

	/* do at least some sanity check... */
	if (argc != 4) {

		printf("\nusage: %s challenge peer-challenge"
		       " username\n", argv[0]);
		return -1;

	}

	/* ok, now get some parameters... */
	genChallengeHash(argv[1], argv[2], argv[3]);

	PutCharArray(challengehash, 8);
	puts("");


	return 0;
}
