/* an example of a chapms-v2 attack */
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "md4.h"

#define MAX_NT_PASSWORD		256
#define MD4_SIGNATURE_SIZE	16

/*  taken from ppp/pppd/extra_crypto.c 
 *  Copyright (c) Tim Hockin, Cobalt Networks Inc. and others 
 */

/* quick wrapper for easy md4 */
void md4(unsigned char *from, int from_len, unsigned char *to)
{
	MD4_CTX Context;

#ifndef __NetBSD__
	from_len <<= 3;		/* bytes->bits */
#endif

	MD4Init(&Context);
	MD4Update(&Context, from, from_len);
	MD4Final(to, &Context);
}

void NtPasswordHash(char *secret, int secret_len, unsigned char *hash)
{
	int i;
	unsigned char unicodePassword[MAX_NT_PASSWORD * 2];

	/* Initialize the Unicode version of the secret (== password). */
	/* This implicitly supports 8-bit ISO8859/1 characters. */
	memset(unicodePassword, 0, sizeof(unicodePassword));

	for (i = 0; i < secret_len; i++)
		unicodePassword[i * 2] = (unsigned char) secret[i];

	/* Unicode is 2 bytes per char */
	md4(unicodePassword, secret_len * 2, hash);
}


/* written from scratch
 * Copyright (C) 2001 Jochen Eisinger, University of Freiburg
 */

#define hex2int(c)	((((c) >= '0') && ((c) <= '9')) ? ((c) - '0') : \
			((((c) >= 'A') && ((c) <= 'F')) ? ((c) - 'A' + 10) : \
			((c) - 'a' + 10)))

/* GetCharArray:
 * 	Convert ASCII String to binary
 */
void GetCharArray(char *s, unsigned char *a)
{

	int i, w;

	for (i = 0; i < strlen(s); i += 2) {

		w = hex2int(s[i]);
		w <<= 4;
		w += hex2int(s[i + 1]);

		a[i >> 1] = w;

	}

}


/* allowed characters in password. only use alpha-numerical chars */

const char letters[] = "abcdefghijklmnopqrstuvwxyz"
    "ABCDEFGHIJKLMNOPQRSTUVWXYZ" "0123456789"
			/* good passwords should also contain one of these */
/*			"+*#~^<>|.;.:-_!$%&/()=?{}[]" */ ;

#define	NUM_LETTERS 	62


/* the password (restricted to 8 chars, we assume it's a unix pw) */
unsigned char password[9] = { 0, 0, 0, 0, 0, 0, 0, 0, 0 };

/* the password hash */
unsigned char pwhash[MD4_SIGNATURE_SIZE];


void filter()
{
	char tmp[64];
	int len;

	while (!feof(stdin)) {

		tmp[0] = 0;

		fgets(tmp, 64, stdin);

		while ((strlen(tmp)) && (isspace(tmp[strlen(tmp) - 1])))
			tmp[strlen(tmp) - 1] = 0;

		if ((len = strlen(tmp)) == 0)
			continue;

		memset(password, 0, 8);

		strncpy(password, tmp, 8);
		NtPasswordHash(password, strlen(password), pwhash);
		printf
		    ("%s\t%02x%02x%02x%02x%02x%02x%02x%02x"
		     "%02x%02x%02x%02x%02x%02x%02x%02x\n",
		     password, pwhash[0], pwhash[1], pwhash[2], pwhash[3],
		     pwhash[4], pwhash[5], pwhash[6], pwhash[7], pwhash[8],
		     pwhash[9], pwhash[10], pwhash[11], pwhash[12],
		     pwhash[13], pwhash[14], pwhash[15]);

	}

}



int main(int argc, char **argv)
{


	/* do at least some sanity check... */
	if (argc != 1) {

		puts
		    ("Copyright (C) 2001 Jochen Eisinger, University of Freiburg");
		printf("\nusage: %s\n", argv[0]);
		return -1;

	}

	filter();

	return 0;
}
